/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-01 at 19:28:25 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.adsense.model;

/**
 * Model definition for Alerts.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the AdSense Management API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Alerts extends com.google.api.client.json.GenericJson {

  /**
   * The alerts returned in this list response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Alert> items;

  /**
   * Kind of list this is, in this case adsense#alerts.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The alerts returned in this list response.
   * @return value or {@code null} for none
   */
  public java.util.List<Alert> getItems() {
    return items;
  }

  /**
   * The alerts returned in this list response.
   * @param items items or {@code null} for none
   */
  public Alerts setItems(java.util.List<Alert> items) {
    this.items = items;
    return this;
  }

  /**
   * Kind of list this is, in this case adsense#alerts.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of list this is, in this case adsense#alerts.
   * @param kind kind or {@code null} for none
   */
  public Alerts setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public Alerts set(String fieldName, Object value) {
    return (Alerts) super.set(fieldName, value);
  }

  @Override
  public Alerts clone() {
    return (Alerts) super.clone();
  }

}
